import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class PictureCanvas extends ScaleCanvas implements MouseListener, MouseMotionListener, KeyListener {
    Manager M;
    Polyhedron[] LIST=new Polyhedron[40];
    Color[] COLOR=new Color[40];
    int count=0;
    Vector[] PROJ=new Vector[2];
    int INIT;
    Point JX;

     public PictureCanvas() {
	 addMouseListener(this);
	 addKeyListener(this);
	 addMouseMotionListener(this);
	 setScales(300,300,50);	
	 INIT=0;
     }

    public PictureCanvas addManager(Manager M) {
	PictureCanvas PP=this;
	PP.M=M;
	return(PP);
    }

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      setFrame();
      setPolyhedra();
      drawBackground(g);
      drawPolyhedraSolid(g);
      drawPoints(g);
   }

    public void drawBackground(Graphics2D g) {
	g.setColor(Color.black);
	g.fillRect(0,0,600,600);
    }

    public void setFrame() {
	Complex[] Z=M.C.Z;
	PROJ=Vector.hemisphere(Z[0]);
    }

    public Color setTransparency(Color C) {

	int n=M.C.SOLID.val;
	n=32*n+31;
	int R=C.getRed();
	int G=C.getGreen();
	int B=C.getBlue();
	Color CC=new Color(R,G,B,n);
	return(CC);
    }




    public void setPolyhedra() {
	double[] a=M.C.a;
	count=0;
	for(int i=0;i<4;++i) {
	    if(M.C.ORTHO.L[i].on==1) {
		LIST[count]=PolyhedronData.PX(i,a);
		Color C=M.C.ORTHO.M[i].C;
		LIST[count].FILL=setTransparency(C);
		LIST[count].OUTLINE=LIST[count].FILL;
		++count;
	    }
	}
	for(int i=0;i<6;++i) {
	    if(M.C.PSEUDO.L[i].on==1) {
		LIST[count]=PolyhedronData.PX(i+4,a);
		Color C=setTransparency(M.C.PSEUDO.M[i].C);	
	        LIST[count].FILL=setTransparency(C);
		LIST[count].OUTLINE=LIST[count].FILL;
		++count;
		if(M.C.PARTNER.on==1) {
	           LIST[count]=Polyhedron.specialRotate(LIST[count-1]);
		   LIST[count].FILL=setTransparency(C);
		   LIST[count].OUTLINE=LIST[count].FILL;
		   ++count;
		}
		    
	    }
	}

	for(int i=0;i<8;++i) {
	    if(M.C.EXTRA.L[i].on==1) {
		LIST[count]=PolyhedronData.PX(i+11,a);	 
                Color C=M.C.EXTRA.M[i].C;
    	        LIST[count].FILL=setTransparency(C);
		LIST[count].OUTLINE=LIST[count].FILL;

		++count;
	    }
	}
    }

    public void drawPolyhedraSolid(Graphics2D g) {
	FaceOrdering FF=new FaceOrdering(LIST,count,PROJ);
       	FF.correctlyOrder();
	for(int j=0;j<count;++j) {
	   GeneralPathColor[] gp=PolyhedronFace.toPathListTotal(FF.LIST[j],PROJ);
	   GeneralPath gp1=new GeneralPath();
	   for(int i=0;i<gp.length;++i) {
	      gp1=transform(gp[i].PATH);
	      g.setColor(gp[i].FILL);
              g.fill(gp1);
	      g.setColor(Color.white);
              g.draw(gp1);
	   }
	}
    }






    public void drawPoints(Graphics2D g) {	
	double[] a=M.C.a;
	for(int i=0;i<15;++i) {
	    Complex z=PolyhedronData.pointX(i,a).project(PROJ);
	    Vector X=new Vector(z.x,z.y,0);
	    GeneralPath gp=X.toPlan(.02);
	    gp=transform(gp);
	    g.setColor(M.C.POINT.M[i].C);
	    if(M.C.POINT.L[i].on==1)  {
                 g.fill(gp);
                 g.draw(gp);
	    }	
	}
    }




    public void mousePressed(MouseEvent e) { }

    
    public void mouseClicked(MouseEvent e) { 
	INIT=1;
	MouseData J=MouseData.process(e);
	int mode=J.mode;
        if(mode==1) scaleUp(J.X,-1);
        if(mode!=1) scaleUp(J.X,+1);
	repaint();
    }


    public void doMouseClick(int mode) { 
        if(mode==1) scaleUp(JX,-1);
        if(mode==3) scaleUp(JX,+1);
	repaint();
    }



     public void mouseReleased(MouseEvent e) {	 
     }

     public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   

     public void mouseMoved(MouseEvent e) {
	MouseData J=MouseData.process(e);
	JX=J.X;
     }

    
     public void mouseDragged(MouseEvent e) {
     }

    public void keyPressed(KeyEvent e) {
	int test=-100;
	char ch=e.getKeyChar();
	if(ch=='z') test=1;   //zoom in
	if(ch=='c') test=3;   //zoom out
        doMouseClick(test);
	repaint();
    }


    public void keyTyped(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {
    }


}

